import java.util.LinkedList;

public class Test12 {

	static int[][] inputs = new int[][] {
		/* Test 0 */ {},
		/* Test 1 */ {5,},
		/* Test 2 */ {5,2,},
		/* Test 3 */ {5,2,8},
		/* Test 4 */ {5,2,8,6,},
		/* Test 5 */ {5,2,8,6,12,},
		/* Test 6 */ {5,2,8,6,12,9,},
		/* Test 7 */ {5,2,8,6,12,9,10,},
		/* Test 8 */ {5,2,8,6,12,9,10,13,},
	};
	
	static int[][] expected = new int[][] {
		/* Test 0 */ {},
		/* Test 1 */ {5,},
		/* Test 2 */ {2,5,},
		/* Test 3 */ {2,5,8},
		/* Test 4 */ {2,5,6,8,},
		/* Test 5 */ {2,5,6,8,12,},
		/* Test 6 */ {2,5,6,8,9,12,},
		/* Test 7 */ {2,5,6,8,9,10,12,},
		/* Test 8 */ {2,5,6,8,9,10,12,13,},
	};
	
	static boolean checkList(LinkedList<Integer> l, int[] reference) {
		// check whether the entries of l match those of the reference array.
		if (l.size( ) != reference.length)
			return false;
		int i = 0;
		for (Integer x : l) {
			if (x != reference[i])
				return false;
			i += 1;
		}
		return true;
	}

	public static void main(String[] args) {
		System.out.println("[Testing BST.toList]");
		BST input = null;
		int passed = 0;
		int failed = 0;
		
		for (int i = 0; i < inputs.length; ++i) {
			int[] inputArray = inputs[i];
			System.out.print("[Test #" + i + " (size: " + inputArray.length + ")]");
			input = TestUtils.arrayToBST(inputArray);
			LinkedList<Integer> output = BST.toList(input);
			boolean ok = checkList(output, expected[i]);
			if (ok) {
				passed += 1;
				System.out.println(" OK");
			} else {
				failed += 1;
				System.out.println(" FAILED");
				System.out.println("  Expected " + TestUtils.arrayToString(expected[i]));
				System.out.println("  Got " + output);
			}
		}
		System.out.println("[" + passed + " tests passed, " + failed + " tests failed]");
		
		System.out.println("Please check coherence of tree in graphics window");
		new Fenetre(input, "A");
	}

}
