public class Test31 {
	public static int[][][] tests = new int[][][] {
		// The following are pairs of randomly generated arrays of integers.
		// The second of each pair is always a permutation of the first.
			/* Test 0 */{ {}, {} },
			/* Test 1 */{ { 80 }, { 80 } },
			/* Test 2 */{ { 41, 67 }, { 67, 41 } },
			/* Test 3 */{ { 33, 7, 38 }, { 7, 38, 33 } },
			/* Test 4 */{ { 60, 33, 7, 33 }, { 7, 33, 33, 60 } },
			/* Test 5 */{ { 85, 71, 19, 51, 22 }, { 71, 22, 51, 85, 19 } },
			/* Test 6 */{ { 56, 42, 65, 47, 65, 8 }, { 65, 47, 65, 42, 56, 8 } },
			/* Test 7 */{ { 7, 72, 34, 9, 86, 76, 74 },
					{ 86, 72, 76, 74, 9, 34, 7 } },
			/* Test 8 */{ { 30, 39, 88, 77, 17, 99, 41, 79 },
					{ 39, 99, 88, 77, 41, 79, 30, 17 } },
			/* Test 9 */{ { 18, 98, 58, 33, 91, 31, 26, 50, 42 },
					{ 42, 31, 50, 18, 91, 26, 33, 58, 98 } },
			/* Test 10 */{ { 41, 16, 71, 11, 95, 35, 3, 41, 0, 27 },
					{ 16, 41, 95, 27, 41, 0, 11, 71, 3, 35 } },
			/* Test 11 */{ { 65, 51, 75, 22, 30, 46, 11, 69, 90, 76, 40 },
					{ 22, 11, 30, 76, 69, 46, 75, 51, 65, 40, 90 } },
			/* Test 12 */{ { 31, 21, 83, 38, 89, 63, 6, 72, 82, 14, 99, 80 },
					{ 83, 80, 21, 31, 89, 82, 63, 72, 38, 14, 99, 6 } },
			/* Test 13 */{
					{ 55, 35, 12, 68, 94, 8, 60, 32, 29, 92, 41, 7, 57 },
					{ 29, 41, 12, 92, 55, 94, 7, 35, 57, 32, 8, 60, 68 } },
			/* Test 14 */{
					{ 20, 42, 18, 31, 49, 19, 25, 87, 13, 41, 12, 55, 46, 54 },
					{ 20, 46, 19, 41, 55, 54, 42, 13, 18, 12, 49, 25, 31, 87 } },
			/* Test 15 */{
					{ 24, 57, 68, 83, 42, 46, 59, 50, 2, 64, 40, 10, 74, 91, 18 },
					{ 40, 2, 83, 59, 42, 91, 24, 68, 10, 46, 64, 50, 74, 18, 57 } },
			/* Test 16 */{
					{ 68, 37, 38, 97, 39, 25, 10, 24, 76, 14, 78, 58, 51, 23,
							57, 86 },
					{ 68, 37, 86, 57, 38, 97, 76, 25, 10, 24, 23, 58, 14, 78,
							39, 51 } },
			/* Test 17 */{
					{ 56, 29, 1, 2, 64, 48, 90, 11, 44, 62, 39, 87, 3, 80, 77,
							74, 40 },
					{ 74, 80, 62, 44, 40, 1, 11, 87, 56, 77, 90, 3, 29, 48, 39,
							2, 64 } },
			/* Test 18 */{
					{ 25, 35, 80, 11, 45, 43, 91, 36, 91, 57, 47, 85, 3, 7, 72,
							90, 56, 43 },
					{ 72, 85, 56, 35, 57, 47, 45, 90, 3, 36, 7, 91, 25, 43, 43,
							80, 91, 11 } },
			/* Test 19 */{
					{ 81, 39, 99, 18, 29, 94, 47, 71, 23, 78, 21, 89, 45, 86,
							64, 41, 86, 4, 29 },
					{ 39, 18, 29, 64, 78, 99, 29, 21, 47, 86, 94, 71, 81, 41,
							89, 86, 45, 23, 4 } },
	};

	public static void main(String[] args) {
		System.out.println("[Testing Set hashCode]");
		int passed = 0;
		int failed = 0;
		for (int i = 0; i < tests.length; ++i) {
			int[] firstArray = tests[i][0];
			int[] secondArray = tests[i][1];
			System.out.print("[Test #" + i + " (size " + firstArray.length + ")] ");
			Set first = TestUtils.arrayToSet(firstArray);
			Set second = TestUtils.arrayToSet(secondArray);
			int firstHash = first.hashCode();
			int secondHash = second.hashCode();
			if (firstHash == secondHash) {
				passed += 1;
				System.out.println("OK");
			} else {
				failed += 1;
				System.out.println("FAILED");
				System.out.print(" -> hash code " + firstHash + " from "
						+ first);
				System.out.print(" -> hash code " + secondHash + " from "
						+ second);
			}
		}
		System.out.println("[" + passed + " tests passed, " + failed
				+ " tests failed]");
	}

}
