public class Test33 {
	static int[][] inputs = new int[][] {
		/* Test 0 */ { },
		/* Test 1 */ { 4 },
		/* Test 2 */ { 4, 1 },
		/* Test 3 */ { 4, 1, 5 },
		/* Test 4 */ { 4, 1, 5, 6 },
		/* Test 5 */ { 4, 1, 5, 6, 2 },
		/* Test 6 */ { 4, 1, 5, 6, 2, 8 },
		/* Test 7 */ { 4, 1, 5, 6, 2, 8, 9 },
		/* Test 8 */ { 4, 1, 5, 6, 2, 8, 9, 7 },
	};
	
	static int[] sizes = new int[] {
		/* Test 0 */ 0,
		/* Test 1 */ 1,
		/* Test 2 */ 4,
		/* Test 3 */ 16,
		/* Test 4 */ 64,
		/* Test 5 */ 189,
		/* Test 6 */ 987,
		/* Test 7 */ 6032,
		/* Test 8 */ 32366,
	};
	
	private static int size(Set s) {
		return s.toList().size();
	}

	public static void main(String[] args) {
		System.out.println("[Testing LeCompteEstBon getResults]");
		int passed = 0;
		int failed = 0;
		double start = System.currentTimeMillis();
		for (int i = 0; i < inputs.length; ++i) {
			int[] input = inputs[i];
			System.out.print("[Test #" + i + " (size: " + input.length 
					+ " seeds, " + sizes[i] + " results)] ");
			LeCompteEstBon test = new LeCompteEstBon(input);
			// LeCompteEstBonAvecMemo test = new LeCompteEstBonAvecMemo(input);
			
			double t0 = System.currentTimeMillis( );
			Set res = test.getResults( );
			int output = size(res);
			double delta = System.currentTimeMillis( ) - t0;
			if (output == sizes[i]) {
				passed += 1;
				System.out.print("OK");
			} else {
				failed += 1;
				System.out.print("FAILED");
				System.out.print(" (got " + output + ")");
			}
			System.out.println(" time = " + delta + "ms");
		}
		System.out.println("[" + passed + " tests passed, " + failed + " failed]");
		System.out.println("Total time: " + (System.currentTimeMillis() - start) + " ms");
	}

}
